#include <iostream>

using namespace std;

void sorted(long long int a[],int k)
{
    long long int p;
    for(int i=0;i<k-1;i++)
    {
        for(int j=i+1;j<k;j++)
        {
            if(a[i]>a[j])
            {
                p=a[i];
                a[i]=a[j];
                a[j]=p;
            }
        }
    }
}

int stepen(long int x)
{
    int br=0;
    while(x!=1)
    {
        x=x/2;
        br=br+1;
    }
    return br;
}

int main()
{
    int n,q,b;
    cin>>n>>q;
    long int a[n];
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        a[i]=stepen(a[i]);
        //cout<<a[i]<<endl;
    }
    int b1[q];
    int b2[q];
    int br[q];
    for(int i=0;i<q;i++)
    {
        cin>>b1[i]>>b2[i];
        b1[i]=b1[i]-1;
        b2[i]=b2[i]-1;
    }
    for(int i=0;i<q;i++)
    {
        b=0;
        br[i]=0;
        for(int l=0;l<=31;l++)
        {
            b=0;
            for(int j=b1[i];j<=b2[i];j++)
            {
                if(a[j]==l)
                {
                    b++;
                }
            }
            if(b>br[i])
            {
                br[i]=b;
            }
        }
    }
    for(int i=0;i<q;i++)
    {
        cout<<br[i]<<endl;
    }
}